package sampleSearchDissociation;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;


/** 
 * Tests the methods of class DNF 
 * @author Wolfgang Gatterbauer
 * @version First Version: May 25, 2013
 * @version This Version: May 25, 2013
 */
public class Test_DNF {
	
	public static void main(String[] args) {
		
		/* --- quick verification that HashMap from list of strings, does recognize duplicate list of strings ---*/
		HashMap<List<String>,Integer> testMap = new HashMap<List<String>,Integer>();
		LinkedList<String> mapKey1 = new LinkedList<String>(Arrays.asList("1", "2"));
		LinkedList<String> mapKey2 = new LinkedList<String>(Arrays.asList("2", "2"));
		LinkedList<String> mapKey3 = new LinkedList<String>(Arrays.asList("1", "2"));

		testMap.put(mapKey1, 11);
		testMap.put(mapKey2, 12);
		testMap.put(mapKey3, 13);
		
		System.out.println("No duplicates in mapping from list of Strings to keys: \n" + testMap + "\n");

		
		/* --- create clauses ---*/
		List<Integer> intList = null;
		intList = new LinkedList<Integer>(Arrays.asList(12, 2, 5));
		Clause clause1 = new Clause(intList);
		Clause clause2 = new Clause(new LinkedList<Integer>(Arrays.asList(13, 2, 6)));
		Clause clause3 = new Clause(new LinkedList<Integer>(Arrays.asList(12, 13, 12)));		 	// note that clause3 is not minimized
		System.out.println("Clauses: \n" + clause1 +", " + clause2 +", " + clause3 + "\n");
		
		
		/* --- create DNF ---*/
		HashSet<Clause> clauseSet = new HashSet<Clause>();	
		clauseSet.add(clause1);
		clauseSet.add(clause2);		
		clauseSet.add(clause3);
		
		DNF exampleDNF = new DNF(clauseSet);
		
		HashMap<Integer,Double> probMap = new HashMap<Integer,Double>();
		probMap.put(12, 0.1);
		probMap.put(2, 0.2);
		probMap.put(5, 0.3);
		probMap.put(13, 0.4);
		probMap.put(2, 0.5);
		probMap.put(6, 0.6);
		
		DNF.setProb(probMap);			// note the static assignment for probabilities
		
		System.out.println("DNF with already minimized clauses: \n" + exampleDNF + "\n");
		
		
		/* --- Scaling probabilities ---*/
		System.out.println("Probabilities before scaling: \n" + DNF.probMap);
		DNF.scaling(0.5);
		System.out.println("Probabilities after scaling with 0.5: \n" + DNF.probMap);
	}
}
